diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
index fa853cf7c..846de0eef 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
@@ -17,22 +17,20 @@ public class WorldFeatureTreeFancy extends WorldFeature
 	protected int leavesID;
 	protected int logID;
 
-    static final byte[] dimensionLookup = {
-        2, 0, 0, 1, 2, 1
-    };
-    Random treeRand;
-    World worldObj;
-    int[] pos = { 0, 0, 0 };
+    static final byte[] axisConversionArray = { 2, 0, 0, 1, 2, 1 };
+    Random rnd;
+    World world;
+    int[] origin = { 0, 0, 0 };
     int height;
     int trunkHeight;
     double trunkHeightScale;
-    double field_875_h;
+    double branchDensity;
     double branchSlope;
-    double field_873_j;
-    double field_872_k;
-    int trunkThickness;
-    int trunkHeightVariance;
-    int leavesHeight;
+    double widthScale;
+    double foliageDensity;
+    int trunkWidth;
+    int heightVariance;
+    int foliageHeight;
     int[][] foliageCoords;
     int heightMod;
 
@@ -45,16 +43,16 @@ public class WorldFeatureTreeFancy extends WorldFeature
     @MethodParametersAnnotation(names = {"leavesID", "logID", "heightMod"})
     public WorldFeatureTreeFancy(int leavesID, int logID, int heightMod)
     {
-        treeRand = new Random();
+        rnd = new Random();
         height = 0;
         trunkHeightScale = 0.6D;
-        field_875_h = 1.0D;
+        branchDensity = 1.0D;
         branchSlope = 0.4D;
-        field_873_j = 1.0D;
-        field_872_k = 1.0D;
-        trunkThickness = 1;
-        trunkHeightVariance = 12;
-        leavesHeight = 4;
+        widthScale = 1.0D;
+        foliageDensity = 1.0D;
+        trunkWidth = 1;
+        heightVariance = 12;
+        foliageHeight = 4;
         this.leavesID = leavesID;
         this.logID = logID;
         this.heightMod = heightMod;
@@ -67,19 +65,19 @@ public class WorldFeatureTreeFancy extends WorldFeature
         {
             trunkHeight = height - 1;
         }
-        int numOfClustersPerY = (int)(1.4D + Math.pow((field_872_k * (double) height) / 13D, 2D));
+        int numOfClustersPerY = (int)(1.4D + Math.pow((foliageDensity * (double) height) / 13D, 2D));
         if (numOfClustersPerY < 1)
         {
             numOfClustersPerY = 1;
         }
         int[][] foliageCoords = new int[numOfClustersPerY * height][4];
-        int yEnd = (pos[1] + height) - leavesHeight;
+        int yEnd = (origin[1] + height) - foliageHeight;
         int foliageCoordsIndex = 1;
-        int topY = pos[1] + trunkHeight;
-        int y = yEnd - pos[1];
-        foliageCoords[0][0] = pos[0];
+        int topY = origin[1] + trunkHeight;
+        int y = yEnd - origin[1];
+        foliageCoords[0][0] = origin[0];
         foliageCoords[0][1] = yEnd;
-        foliageCoords[0][2] = pos[2];
+        foliageCoords[0][2] = origin[2];
         foliageCoords[0][3] = topY;
         yEnd--;
         while (y >= 0) {
@@ -90,17 +88,17 @@ public class WorldFeatureTreeFancy extends WorldFeature
             } else {
                 double offset = 0.5D;
                 for (int i = 0; i < numOfClustersPerY; i++) {
-                    double r = field_873_j * ((double)shapeFac * ((double) treeRand.nextFloat() + 0.328D));
-                    double theta = (double) treeRand.nextFloat() * 2D * Math.PI;
-                    int x = MathHelper.floor_double(r * Math.sin(theta) + (double) pos[0] + offset);
-                    int z = MathHelper.floor_double(r * Math.cos(theta) + (double) pos[2] + offset);
+                    double r = widthScale * ((double)shapeFac * ((double) rnd.nextFloat() + 0.328D));
+                    double theta = (double) rnd.nextFloat() * 2D * Math.PI;
+                    int x = MathHelper.floor(r * Math.sin(theta) + (double) origin[0] + offset);
+                    int z = MathHelper.floor(r * Math.cos(theta) + (double) origin[2] + offset);
                     int[] branchEnd = { x, yEnd, z };
-                    int[] branchTopOfTree = { x, yEnd + leavesHeight, z };
+                    int[] branchTopOfTree = { x, yEnd + foliageHeight, z };
                     if (distToMat(branchEnd, branchTopOfTree) != -1) {
                         continue;
                     }
-                    int[] branchStart = { pos[0], pos[1], pos[2] };
-                    double dist = Math.sqrt(Math.pow(Math.abs(pos[0] - branchEnd[0]), 2D) + Math.pow(Math.abs(pos[2] - branchEnd[2]), 2D));
+                    int[] branchStart = { origin[0], origin[1], origin[2] };
+                    double dist = Math.sqrt(Math.pow(Math.abs(origin[0] - branchEnd[0]), 2D) + Math.pow(Math.abs(origin[2] - branchEnd[2]), 2D));
                     if ((double)branchEnd[1] - dist * branchSlope > (double)topY) {
                         branchStart[1] = topY;
                     }
@@ -143,10 +141,10 @@ public class WorldFeatureTreeFancy extends WorldFeature
                 double thisDist = Math.sqrt(Math.pow((double) Math.abs(off1) + 0.5D, 2D) + Math.pow((double) Math.abs(off2) + 0.5D, 2D));
                 if(thisDist <= (double)radius)
                 {
-                    int id = worldObj.getBlockId(coord[0], coord[1], coord[2]);
+                    int id = world.getBlockId(coord[0], coord[1], coord[2]);
                     if (id == 0 || id == leavesID)
                     {
-                        worldObj.setBlockWithNotify(coord[0], coord[1], coord[2], blockId);
+                        world.setBlockWithNotify(coord[0], coord[1], coord[2], blockId);
                     }
                 }
             }
@@ -175,11 +173,11 @@ public class WorldFeatureTreeFancy extends WorldFeature
 
     float getFoliageShape(int y)
     {
-        if(y < 0 || y >= leavesHeight)
+        if(y < 0 || y >= foliageHeight)
         {
             return -1F;
         }
-        else if (y == 0 || y == leavesHeight - 1)
+        else if (y == 0 || y == foliageHeight - 1)
         {
             return 2F;
         }
@@ -191,7 +189,7 @@ public class WorldFeatureTreeFancy extends WorldFeature
 
     void foliageCluster(int x, int y, int z)
     {
-        for(int leavesY = y; leavesY < y + leavesHeight; leavesY++)
+        for(int leavesY = y; leavesY < y + foliageHeight; leavesY++)
         {
             float radius = getFoliageShape(leavesY - y);
             crossSection(x, leavesY, z, radius, leavesID);
@@ -230,8 +228,8 @@ public class WorldFeatureTreeFancy extends WorldFeature
         }
 
         // Look up other two dimensions
-        byte dim1 = dimensionLookup[dim0];
-        byte dim2 = dimensionLookup[dim0 + 3];
+        byte dim1 = axisConversionArray[dim0];
+        byte dim2 = axisConversionArray[dim0 + 3];
 
         byte delta;
         if(dimensions[dim0] > 0)
@@ -251,10 +249,10 @@ public class WorldFeatureTreeFancy extends WorldFeature
         for(int i = 0; i != dimensions[dim0] + delta; i += delta)
         {
             int[] pos = { 0, 0, 0 };
-            pos[dim0] = MathHelper.floor_double((double)startPos[dim0] + (double)i + 0.5D);
-            pos[dim1] = MathHelper.floor_double((double)startPos[dim1] + (double)i * dim1DeltaScale + 0.5D);
-            pos[dim2] = MathHelper.floor_double((double)startPos[dim2] + (double)i * dim2DeltaScale + 0.5D);
-            worldObj.setBlockWithNotify(pos[0], pos[1], pos[2], blockId);
+            pos[dim0] = MathHelper.floor((double)startPos[dim0] + (double)i + 0.5D);
+            pos[dim1] = MathHelper.floor((double)startPos[dim1] + (double)i * dim1DeltaScale + 0.5D);
+            pos[dim2] = MathHelper.floor((double)startPos[dim2] + (double)i * dim2DeltaScale + 0.5D);
+            world.setBlockWithNotify(pos[0], pos[1], pos[2], blockId);
         }
     }
 
@@ -265,14 +263,14 @@ public class WorldFeatureTreeFancy extends WorldFeature
 
     void makeTrunk()
     {
-        int x = pos[0];
-        int minY = pos[1];
-        int maxY = pos[1] + trunkHeight;
-        int z = pos[2];
+        int x = origin[0];
+        int minY = origin[1];
+        int maxY = origin[1] + trunkHeight;
+        int z = origin[2];
         int[] startPos = { x, minY, z };
         int[] endPos = { x, maxY, z };
         makeBranch(startPos, endPos, logID);
-        if(trunkThickness == 2)
+        if(trunkWidth == 2)
         {
             startPos[0]++;
             endPos[0]++;
@@ -288,12 +286,12 @@ public class WorldFeatureTreeFancy extends WorldFeature
 
     void makeBranches()
     {
-        int[] startPos = { pos[0], pos[1], pos[2] };
+        int[] startPos = { origin[0], origin[1], origin[2] };
         for (int[] branchPoint : foliageCoords)
         {
             int[] endPos = { branchPoint[0], branchPoint[1], branchPoint[2] };
             startPos[1] = branchPoint[3];
-            int dy = startPos[1] - pos[1];
+            int dy = startPos[1] - origin[1];
             if (isHighEnoughToBranch(dy))
             {
                 makeBranch(startPos, endPos, logID);
@@ -322,8 +320,8 @@ public class WorldFeatureTreeFancy extends WorldFeature
         }
 
         // Look up other two dimensions
-        byte dim1 = dimensionLookup[dim0];
-        byte dim2 = dimensionLookup[dim0 + 3];
+        byte dim1 = axisConversionArray[dim0];
+        byte dim2 = axisConversionArray[dim0 + 3];
 
         byte delta;
         if(dimensions[dim0] > 0)
@@ -346,9 +344,9 @@ public class WorldFeatureTreeFancy extends WorldFeature
         {
             int[] pos = { 0, 0, 0 };
             pos[dim0] = startPos[dim0] + linePos;
-            pos[dim1] = MathHelper.floor_double((double)startPos[dim1] + (double)linePos * dim1DeltaScale);
-            pos[dim2] = MathHelper.floor_double((double)startPos[dim2] + (double)linePos * dim2DeltaScale);
-            int idAtPos = worldObj.getBlockId(pos[0], pos[1], pos[2]);
+            pos[dim1] = MathHelper.floor((double)startPos[dim1] + (double)linePos * dim1DeltaScale);
+            pos[dim2] = MathHelper.floor((double)startPos[dim2] + (double)linePos * dim2DeltaScale);
+            int idAtPos = world.getBlockId(pos[0], pos[1], pos[2]);
             if(idAtPos != 0 && idAtPos != leavesID)
             {
                 break;
@@ -369,9 +367,9 @@ public class WorldFeatureTreeFancy extends WorldFeature
 
     boolean canGenerateTree()
     {
-        int[] bottomPos = { pos[0], pos[1], pos[2] };
-        int[] topPos = { pos[0], (pos[1] + height) - 1, pos[2] };
-        int blockIdUnderneath = worldObj.getBlockId(pos[0], pos[1] - 1, pos[2]);
+        int[] bottomPos = { origin[0], origin[1], origin[2] };
+        int[] topPos = { origin[0], (origin[1] + height) - 1, origin[2] };
+        int blockIdUnderneath = world.getBlockId(origin[0], origin[1] - 1, origin[2]);
         if(!Block.hasTag(blockIdUnderneath, BlockTags.GROWS_TREES))
         {
             return false;
@@ -393,33 +391,33 @@ public class WorldFeatureTreeFancy extends WorldFeature
     }
 
     @Override
-	public void func_517_a(double d, double d1, double d2)
+	public void init(double d, double d1, double d2)
     {
-        trunkHeightVariance = (int)(d * (12D + heightMod));
+        heightVariance = (int)(d * (12D + heightMod));
         if(d > 0.5D)
         {
-            leavesHeight = 5;
+            foliageHeight = 5;
         }
-        field_873_j = d1;
-        field_872_k = d2;
+        widthScale = d1;
+        foliageDensity = d2;
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
-        worldObj = world;
+        this.world = world;
         long seed = random.nextLong();
-        treeRand.setSeed(seed);
-        pos[0] = x;
-        pos[1] = y;
-        pos[2] = z;
+        rnd.setSeed(seed);
+        origin[0] = x;
+        origin[1] = y;
+        origin[2] = z;
         if(height == 0)
         {
-            height = 5 + treeRand.nextInt(trunkHeightVariance);
+            height = 5 + rnd.nextInt(heightVariance);
         }
         if(canGenerateTree())
         {
-            WorldFeatureTree.onTreeGrown(worldObj, pos[0], pos[1], pos[2]);
+            WorldFeatureTree.onTreeGrown(this.world, origin[0], origin[1], origin[2]);
             prepare();
             makeFoliage();
             makeTrunk();
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
index 3456bdc86..e5c5d7cb6 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
@@ -88,8 +88,8 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
                 {
                     double d1 = field_873_j * ((double)f * ((double)treeRand.nextFloat() + 0.32800000000000001D));
                     double d2 = (double)treeRand.nextFloat() * 2D * 3.1415899999999999D;
-                    int k1 = MathHelper.floor_double(d1 * java.lang.Math.sin(d2) + (double)basePos[0] + d);
-                    int l1 = MathHelper.floor_double(d1 * java.lang.Math.cos(d2) + (double)basePos[2] + d);
+                    int k1 = MathHelper.floor(d1 * java.lang.Math.sin(d2) + (double)basePos[0] + d);
+                    int l1 = MathHelper.floor(d1 * java.lang.Math.cos(d2) + (double)basePos[2] + d);
                     int ai1[] = {
                         k1, j, l1
                     };
@@ -280,9 +280,9 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
         int k = 0;
         for(int l = ai2[j] + byte3; k != l; k += byte3)
         {
-            ai3[j] = MathHelper.floor_double((double)(ai[j] + k) + 0.5D);
-            ai3[byte1] = MathHelper.floor_double((double)ai[byte1] + (double)k * d + 0.5D);
-            ai3[byte2] = MathHelper.floor_double((double)ai[byte2] + (double)k * d1 + 0.5D);
+            ai3[j] = MathHelper.floor((double)(ai[j] + k) + 0.5D);
+            ai3[byte1] = MathHelper.floor((double)ai[byte1] + (double)k * d + 0.5D);
+            ai3[byte2] = MathHelper.floor((double)ai[byte2] + (double)k * d1 + 0.5D);
             worldObj.setBlockWithNotify(ai3[0], ai3[1], ai3[2], i);
         }
 
@@ -387,8 +387,8 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
                 break;
             }
             ai3[i] = ai[i] + j;
-            ai3[byte1] = MathHelper.floor_double((double)ai[byte1] + (double)j * d);
-            ai3[byte2] = MathHelper.floor_double((double)ai[byte2] + (double)j * d1);
+            ai3[byte1] = MathHelper.floor((double)ai[byte1] + (double)j * d);
+            ai3[byte2] = MathHelper.floor((double)ai[byte2] + (double)j * d1);
             int l = worldObj.getBlockId(ai3[0], ai3[1], ai3[2]);
             if(l != 0 && l != leavesID)
             {
@@ -435,7 +435,7 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
     }
 
     @Override
-	public void func_517_a(double d, double d1, double d2)
+	public void init(double d, double d1, double d2)
     {
         field_870_m = (int)(d * (12D+heightMod));
         if(d > 0.5D)
@@ -447,7 +447,7 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         worldObj = world;
         long l = random.nextLong();
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
index 70641d5bc..648ddfb28 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
@@ -1,9 +1,10 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFlower;
-import net.minecraft.core.block.BlockLeavesBase;
-import net.minecraft.core.block.BlockLog;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.FlowerBlock;
+import net.minecraft.core.block.BaseLeavesBlock;
+import net.minecraft.core.block.LogBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
@@ -61,7 +62,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	}
 
 	@Override
-	public boolean generate(World world, Random random, int x, int y, int z) {
+	public boolean place(World world, Random random, int x, int y, int z) {
 		this.world = world;
 		this.random = random;
 		this.basePos = new ChunkPosition(x, y, z);
@@ -110,7 +111,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		// Generate all log block positions
 		for(int i=0; i < height; i++) {
 			float yFactor = i / (float) height;
-			int offset = MathHelper.floor_double(Math.pow(yFactor, angle + 1.0f) * bend);
+			int offset = MathHelper.floor(Math.pow(yFactor, angle + 1.0f) * bend);
 			
 			int offsetX = direction.getOffsetX() * offset;
 			int offsetY = i;
@@ -176,13 +177,13 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		Block block = Block.getBlock(id);
 		
 		// TODO Create BlockTag and apply to all trees
-		if(block instanceof BlockLog) {
+		if(block instanceof LogBlock) {
 			return true;
 		}
-		if(block instanceof BlockLeavesBase) {
+		if(block instanceof BaseLeavesBlock) {
 			return true;
 		}
-		if(block instanceof BlockFlower) {
+		if(block instanceof FlowerBlock) {
 			return true;
 		}
 		return false;
@@ -331,7 +332,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	}
 	
 	public boolean canGrowOnThisBlock(int id, int x, int y, int z) {
-		return Block.hasTag(id, BlockTags.GROWS_TREES) || (id == Block.sand.id && waterNearby(x, y, z));
+		return Block.hasTag(id, BlockTags.GROWS_TREES) || (id == Blocks.SAND.id && waterNearby(x, y, z));
 	}
 	
 	public static int encode(int x, int y, int z) {
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
index f8993efec..ab52ab5ad 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -11,7 +12,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, BlockLeaves,
-//            BlockGrass
+//            GrassBlock
 
 public class WorldFeatureTreeShapeSwamp extends WorldFeature
 {
@@ -28,7 +29,7 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         int trunkLength = random.nextInt(4) + heightMod;
         boolean flag = true;
@@ -73,7 +74,7 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
             return false;
         }
         int sinkToFloor = 0;
-        for(; world.getBlockId(x, (y -sinkToFloor)-1, z)==Block.fluidWaterStill.id; sinkToFloor++) {
+        for(; world.getBlockId(x, (y -sinkToFloor)-1, z)==Blocks.FLUID_WATER_STILL.id; sinkToFloor++) {
 
             if (sinkToFloor > 3)
                 return false;
@@ -86,7 +87,7 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
             return false;
         }
         WorldFeatureTree.onTreeGrown(world, x, y, z);
-        world.setBlockWithNotify(x, y - 1, z, Block.dirt.id);
+        world.setBlockWithNotify(x, y - 1, z, Blocks.DIRT.id);
         for(int k1 = (y - 3) + trunkLength + sinkToFloor; k1 <= y + trunkLength + sinkToFloor; k1++)
         {
             int j2 = k1 - (y + trunkLength + sinkToFloor);
@@ -121,13 +122,13 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
         for(int l1 = 0; l1 < trunkLength + sinkToFloor; l1++)
         {
             int k2 = world.getBlockId(x, y + l1, z);
-            if(k2 == 0 || k2 == leavesID || k2 == Block.fluidWaterStill.id || k2 == Block.fluidWaterFlowing.id)
+            if(k2 == 0 || k2 == leavesID || k2 == Blocks.FLUID_WATER_STILL.id || k2 == Blocks.FLUID_WATER_FLOWING.id)
             {
                 world.setBlockWithNotify(x, y + l1, z, logID);
             }
         }
 
-        (new WorldFeatureAlgae()).generate(world, treeRand, x, oldY-1, z);
+        (new WorldFeatureAlgae()).place(world, treeRand, x, oldY-1, z);
 
         return true;
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
index 0f212cbba..19969007d 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -11,7 +12,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, BlockLeaves,
-//            BlockGrass
+//            GrassBlock
 
 public class WorldFeatureTreeShrub extends WorldFeature
 {
@@ -27,7 +28,7 @@ public class WorldFeatureTreeShrub extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         int maxHeight = 1;
         boolean flag = true;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
index 70bea77a4..69498f366 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -10,7 +11,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, BlockLeaves, 
-//            BlockGrass
+//            GrassBlock
 
 public class WorldFeatureTreeTaigaBushy extends WorldFeature
 {
@@ -25,7 +26,7 @@ public class WorldFeatureTreeTaigaBushy extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         int heightMod = random.nextInt(2) + 10;
         int l = random.nextInt(4) + heightMod;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
index 9e6dfc7bf..a226aed51 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -10,7 +11,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, BlockLeaves, 
-//            BlockGrass
+//            GrassBlock
 
 public class WorldFeatureTreeTaigaTall extends WorldFeature
 {
@@ -24,7 +25,7 @@ public class WorldFeatureTreeTaigaTall extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         int l = random.nextInt(5) + 7;
         int i1 = l - random.nextInt(2) - 3;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
index ffcec1a3b..7f5e71352 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -10,7 +11,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, BlockLeaves,
-//            BlockGrass
+//            GrassBlock
 
 public class WorldFeatureTreeTall extends WorldFeature
 {
@@ -25,7 +26,7 @@ public class WorldFeatureTreeTall extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         int trunkHeight = random.nextInt(5) + 10;
         boolean flag = true;
@@ -136,7 +137,7 @@ public class WorldFeatureTreeTall extends WorldFeature
                     world.setBlockAndMetadataWithNotify(x + xOffset, y + yOffset, z + zOffset, logID, onXAxis? 2 : 1);
                     if(random.nextInt(10)==0){
                         if(world.getBlockId(x + xOffset, y + yOffset+1, z + zOffset)==0)
-                            world.setBlockWithNotify(x + xOffset, y + yOffset+1, z + zOffset, Block.mushroomBrown.id);
+                            world.setBlockWithNotify(x + xOffset, y + yOffset+1, z + zOffset, Blocks.MUSHROOM_BROWN.id);
                     }
             }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
index 9e14f2184..7fabb3cb3 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -121,7 +122,7 @@ public abstract class WorldFeatureSpoonerTree
     }
 
     @Override
-    public boolean generate(World world, Random random, int x, int y, int z) {
+    public boolean place(World world, Random random, int x, int y, int z) {
         this.random = random;
         this.pos = new int[] { x, y, z };
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
index 4fb1cc92a..2e2361485 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
@@ -28,7 +28,7 @@ public abstract class WorldFeatureSpoonerTreeProcedural
     }
 
     protected void crossSection(int[] center, double radius, int dirAxis, int id, int data, World world) {
-        int rad = MathHelper.floor_double(radius + 0.618);
+        int rad = MathHelper.floor(radius + 0.618);
         int secidx1 = (dirAxis + 1) % 3;
         int secidx2 = (dirAxis + 2) % 3;
         int[] coord = new int[3];
diff --git a/src/main/java/net/minecraft/core/world/pathfinder/Path.java b/src/main/java/net/minecraft/core/world/pathfinder/Path.java
index 5105dd4de..1de15536f 100644
--- a/src/main/java/net/minecraft/core/world/pathfinder/Path.java
+++ b/src/main/java/net/minecraft/core/world/pathfinder/Path.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.pathfinder;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 
 public class Path
 {
@@ -37,11 +37,11 @@ public class Path
         }
     }
 
-    public Vec3d getPos(Entity entity)
+    public Vec3 getPos(Entity entity)
     {
         double x = (double) nodes[index].x + (double)(int)(entity.bbWidth + 2.0F) * 0.5D;
         double y = nodes[index].y;
         double z = (double) nodes[index].z + (double)(int)(entity.bbWidth + 2.0F) * 0.5D;
-        return Vec3d.createVector(x, y, z);
+        return Vec3.getTempVec3(x, y, z);
     }
 }
